git-submodule.shon commit submodule: ensure that -c http.extraheader is heeded (0bbe731)
   1#!/bin/sh
   2#
   3# git-submodule.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
  12   or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
  13   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  14   or: $dashless [--quiet] foreach [--recursive] <command>
  15   or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
  16OPTIONS_SPEC=
  17SUBDIRECTORY_OK=Yes
  18. git-sh-setup
  19. git-sh-i18n
  20. git-parse-remote
  21require_work_tree
  22wt_prefix=$(git rev-parse --show-prefix)
  23cd_to_toplevel
  24
  25# Restrict ourselves to a vanilla subset of protocols; the URLs
  26# we get are under control of a remote repository, and we do not
  27# want them kicking off arbitrary git-remote-* programs.
  28#
  29# If the user has already specified a set of allowed protocols,
  30# we assume they know what they're doing and use that instead.
  31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
  32export GIT_ALLOW_PROTOCOL
  33
  34command=
  35branch=
  36force=
  37reference=
  38cached=
  39recursive=
  40init=
  41files=
  42remote=
  43nofetch=
  44update=
  45prefix=
  46custom_name=
  47depth=
  48
  49# The function takes at most 2 arguments. The first argument is the
  50# URL that navigates to the submodule origin repo. When relative, this URL
  51# is relative to the superproject origin URL repo. The second up_path
  52# argument, if specified, is the relative path that navigates
  53# from the submodule working tree to the superproject working tree.
  54#
  55# The output of the function is the origin URL of the submodule.
  56#
  57# The output will either be an absolute URL or filesystem path (if the
  58# superproject origin URL is an absolute URL or filesystem path,
  59# respectively) or a relative file system path (if the superproject
  60# origin URL is a relative file system path).
  61#
  62# When the output is a relative file system path, the path is either
  63# relative to the submodule working tree, if up_path is specified, or to
  64# the superproject working tree otherwise.
  65resolve_relative_url ()
  66{
  67        remote=$(get_default_remote)
  68        remoteurl=$(git config "remote.$remote.url") ||
  69                remoteurl=$(pwd) # the repository is its own authoritative upstream
  70        url="$1"
  71        remoteurl=${remoteurl%/}
  72        sep=/
  73        up_path="$2"
  74
  75        case "$remoteurl" in
  76        *:*|/*)
  77                is_relative=
  78                ;;
  79        ./*|../*)
  80                is_relative=t
  81                ;;
  82        *)
  83                is_relative=t
  84                remoteurl="./$remoteurl"
  85                ;;
  86        esac
  87
  88        while test -n "$url"
  89        do
  90                case "$url" in
  91                ../*)
  92                        url="${url#../}"
  93                        case "$remoteurl" in
  94                        */*)
  95                                remoteurl="${remoteurl%/*}"
  96                                ;;
  97                        *:*)
  98                                remoteurl="${remoteurl%:*}"
  99                                sep=:
 100                                ;;
 101                        *)
 102                                if test -z "$is_relative" || test "." = "$remoteurl"
 103                                then
 104                                        die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
 105                                else
 106                                        remoteurl=.
 107                                fi
 108                                ;;
 109                        esac
 110                        ;;
 111                ./*)
 112                        url="${url#./}"
 113                        ;;
 114                *)
 115                        break;;
 116                esac
 117        done
 118        remoteurl="$remoteurl$sep${url%/}"
 119        echo "${is_relative:+${up_path}}${remoteurl#./}"
 120}
 121
 122# Resolve a path to be relative to another path.  This is intended for
 123# converting submodule paths when git-submodule is run in a subdirectory
 124# and only handles paths where the directory separator is '/'.
 125#
 126# The output is the first argument as a path relative to the second argument,
 127# which defaults to $wt_prefix if it is omitted.
 128relative_path ()
 129{
 130        local target curdir result
 131        target=$1
 132        curdir=${2-$wt_prefix}
 133        curdir=${curdir%/}
 134        result=
 135
 136        while test -n "$curdir"
 137        do
 138                case "$target" in
 139                "$curdir/"*)
 140                        target=${target#"$curdir"/}
 141                        break
 142                        ;;
 143                esac
 144
 145                result="${result}../"
 146                if test "$curdir" = "${curdir%/*}"
 147                then
 148                        curdir=
 149                else
 150                        curdir="${curdir%/*}"
 151                fi
 152        done
 153
 154        echo "$result$target"
 155}
 156
 157die_if_unmatched ()
 158{
 159        if test "$1" = "#unmatched"
 160        then
 161                exit 1
 162        fi
 163}
 164
 165#
 166# Print a submodule configuration setting
 167#
 168# $1 = submodule name
 169# $2 = option name
 170# $3 = default value
 171#
 172# Checks in the usual git-config places first (for overrides),
 173# otherwise it falls back on .gitmodules.  This allows you to
 174# distribute project-wide defaults in .gitmodules, while still
 175# customizing individual repositories if necessary.  If the option is
 176# not in .gitmodules either, print a default value.
 177#
 178get_submodule_config () {
 179        name="$1"
 180        option="$2"
 181        default="$3"
 182        value=$(git config submodule."$name"."$option")
 183        if test -z "$value"
 184        then
 185                value=$(git config -f .gitmodules submodule."$name"."$option")
 186        fi
 187        printf '%s' "${value:-$default}"
 188}
 189
 190isnumber()
 191{
 192        n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
 193}
 194
 195# Sanitize the local git environment for use within a submodule. We
 196# can't simply use clear_local_git_env since we want to preserve some
 197# of the settings from GIT_CONFIG_PARAMETERS.
 198sanitize_submodule_env()
 199{
 200        save_config=$GIT_CONFIG_PARAMETERS
 201        clear_local_git_env
 202        GIT_CONFIG_PARAMETERS=$save_config
 203        export GIT_CONFIG_PARAMETERS
 204}
 205
 206#
 207# Add a new submodule to the working tree, .gitmodules and the index
 208#
 209# $@ = repo path
 210#
 211# optional branch is stored in global branch variable
 212#
 213cmd_add()
 214{
 215        # parse $args after "submodule ... add".
 216        reference_path=
 217        while test $# -ne 0
 218        do
 219                case "$1" in
 220                -b | --branch)
 221                        case "$2" in '') usage ;; esac
 222                        branch=$2
 223                        shift
 224                        ;;
 225                -f | --force)
 226                        force=$1
 227                        ;;
 228                -q|--quiet)
 229                        GIT_QUIET=1
 230                        ;;
 231                --reference)
 232                        case "$2" in '') usage ;; esac
 233                        reference_path=$2
 234                        shift
 235                        ;;
 236                --reference=*)
 237                        reference_path="${1#--reference=}"
 238                        ;;
 239                --name)
 240                        case "$2" in '') usage ;; esac
 241                        custom_name=$2
 242                        shift
 243                        ;;
 244                --depth)
 245                        case "$2" in '') usage ;; esac
 246                        depth="--depth=$2"
 247                        shift
 248                        ;;
 249                --depth=*)
 250                        depth=$1
 251                        ;;
 252                --)
 253                        shift
 254                        break
 255                        ;;
 256                -*)
 257                        usage
 258                        ;;
 259                *)
 260                        break
 261                        ;;
 262                esac
 263                shift
 264        done
 265
 266        if test -n "$reference_path"
 267        then
 268                is_absolute_path "$reference_path" ||
 269                reference_path="$wt_prefix$reference_path"
 270
 271                reference="--reference=$reference_path"
 272        fi
 273
 274        repo=$1
 275        sm_path=$2
 276
 277        if test -z "$sm_path"; then
 278                sm_path=$(printf '%s\n' "$repo" |
 279                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 280        fi
 281
 282        if test -z "$repo" || test -z "$sm_path"; then
 283                usage
 284        fi
 285
 286        is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
 287
 288        # assure repo is absolute or relative to parent
 289        case "$repo" in
 290        ./*|../*)
 291                test -z "$wt_prefix" ||
 292                die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
 293
 294                # dereference source url relative to parent's url
 295                realrepo=$(resolve_relative_url "$repo") || exit
 296                ;;
 297        *:*|/*)
 298                # absolute url
 299                realrepo=$repo
 300                ;;
 301        *)
 302                die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
 303        ;;
 304        esac
 305
 306        # normalize path:
 307        # multiple //; leading ./; /./; /../; trailing /
 308        sm_path=$(printf '%s/\n' "$sm_path" |
 309                sed -e '
 310                        s|//*|/|g
 311                        s|^\(\./\)*||
 312                        s|/\(\./\)*|/|g
 313                        :start
 314                        s|\([^/]*\)/\.\./||
 315                        tstart
 316                        s|/*$||
 317                ')
 318        git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
 319        die "$(eval_gettext "'\$sm_path' already exists in the index")"
 320
 321        if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
 322        then
 323                eval_gettextln "The following path is ignored by one of your .gitignore files:
 324\$sm_path
 325Use -f if you really want to add it." >&2
 326                exit 1
 327        fi
 328
 329        if test -n "$custom_name"
 330        then
 331                sm_name="$custom_name"
 332        else
 333                sm_name="$sm_path"
 334        fi
 335
 336        # perhaps the path exists and is already a git repo, else clone it
 337        if test -e "$sm_path"
 338        then
 339                if test -d "$sm_path"/.git || test -f "$sm_path"/.git
 340                then
 341                        eval_gettextln "Adding existing repo at '\$sm_path' to the index"
 342                else
 343                        die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
 344                fi
 345
 346        else
 347                if test -d ".git/modules/$sm_name"
 348                then
 349                        if test -z "$force"
 350                        then
 351                                echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
 352                                GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
 353                                echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
 354                                echo >&2 "  $realrepo"
 355                                echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
 356                                die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
 357                        else
 358                                echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
 359                        fi
 360                fi
 361                git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
 362                (
 363                        sanitize_submodule_env
 364                        cd "$sm_path" &&
 365                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 366                        case "$branch" in
 367                        '') git checkout -f -q ;;
 368                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 369                        esac
 370                ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
 371        fi
 372        git config submodule."$sm_name".url "$realrepo"
 373
 374        git add $force "$sm_path" ||
 375        die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
 376
 377        git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
 378        git config -f .gitmodules submodule."$sm_name".url "$repo" &&
 379        if test -n "$branch"
 380        then
 381                git config -f .gitmodules submodule."$sm_name".branch "$branch"
 382        fi &&
 383        git add --force .gitmodules ||
 384        die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
 385}
 386
 387#
 388# Execute an arbitrary command sequence in each checked out
 389# submodule
 390#
 391# $@ = command to execute
 392#
 393cmd_foreach()
 394{
 395        # parse $args after "submodule ... foreach".
 396        while test $# -ne 0
 397        do
 398                case "$1" in
 399                -q|--quiet)
 400                        GIT_QUIET=1
 401                        ;;
 402                --recursive)
 403                        recursive=1
 404                        ;;
 405                -*)
 406                        usage
 407                        ;;
 408                *)
 409                        break
 410                        ;;
 411                esac
 412                shift
 413        done
 414
 415        toplevel=$(pwd)
 416
 417        # dup stdin so that it can be restored when running the external
 418        # command in the subshell (and a recursive call to this function)
 419        exec 3<&0
 420
 421        git submodule--helper list --prefix "$wt_prefix"|
 422        while read mode sha1 stage sm_path
 423        do
 424                die_if_unmatched "$mode"
 425                if test -e "$sm_path"/.git
 426                then
 427                        displaypath=$(relative_path "$sm_path")
 428                        say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
 429                        name=$(git submodule--helper name "$sm_path")
 430                        (
 431                                prefix="$prefix$sm_path/"
 432                                sanitize_submodule_env
 433                                cd "$sm_path" &&
 434                                sm_path=$(relative_path "$sm_path") &&
 435                                # we make $path available to scripts ...
 436                                path=$sm_path &&
 437                                if test $# -eq 1
 438                                then
 439                                        eval "$1"
 440                                else
 441                                        "$@"
 442                                fi &&
 443                                if test -n "$recursive"
 444                                then
 445                                        cmd_foreach "--recursive" "$@"
 446                                fi
 447                        ) <&3 3<&- ||
 448                        die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
 449                fi
 450        done
 451}
 452
 453#
 454# Register submodules in .git/config
 455#
 456# $@ = requested paths (default to all)
 457#
 458cmd_init()
 459{
 460        # parse $args after "submodule ... init".
 461        while test $# -ne 0
 462        do
 463                case "$1" in
 464                -q|--quiet)
 465                        GIT_QUIET=1
 466                        ;;
 467                --)
 468                        shift
 469                        break
 470                        ;;
 471                -*)
 472                        usage
 473                        ;;
 474                *)
 475                        break
 476                        ;;
 477                esac
 478                shift
 479        done
 480
 481        git submodule--helper list --prefix "$wt_prefix" "$@" |
 482        while read mode sha1 stage sm_path
 483        do
 484                die_if_unmatched "$mode"
 485                name=$(git submodule--helper name "$sm_path") || exit
 486
 487                displaypath=$(relative_path "$sm_path")
 488
 489                # Copy url setting when it is not set yet
 490                if test -z "$(git config "submodule.$name.url")"
 491                then
 492                        url=$(git config -f .gitmodules submodule."$name".url)
 493                        test -z "$url" &&
 494                        die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
 495
 496                        # Possibly a url relative to parent
 497                        case "$url" in
 498                        ./*|../*)
 499                                url=$(resolve_relative_url "$url") || exit
 500                                ;;
 501                        esac
 502                        git config submodule."$name".url "$url" ||
 503                        die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
 504
 505                        say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
 506                fi
 507
 508                # Copy "update" setting when it is not set yet
 509                if upd="$(git config -f .gitmodules submodule."$name".update)" &&
 510                   test -n "$upd" &&
 511                   test -z "$(git config submodule."$name".update)"
 512                then
 513                        case "$upd" in
 514                        checkout | rebase | merge | none)
 515                                ;; # known modes of updating
 516                        *)
 517                                echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
 518                                upd=none
 519                                ;;
 520                        esac
 521                        git config submodule."$name".update "$upd" ||
 522                        die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
 523                fi
 524        done
 525}
 526
 527#
 528# Unregister submodules from .git/config and remove their work tree
 529#
 530# $@ = requested paths (use '.' to deinit all submodules)
 531#
 532cmd_deinit()
 533{
 534        # parse $args after "submodule ... deinit".
 535        while test $# -ne 0
 536        do
 537                case "$1" in
 538                -f|--force)
 539                        force=$1
 540                        ;;
 541                -q|--quiet)
 542                        GIT_QUIET=1
 543                        ;;
 544                --)
 545                        shift
 546                        break
 547                        ;;
 548                -*)
 549                        usage
 550                        ;;
 551                *)
 552                        break
 553                        ;;
 554                esac
 555                shift
 556        done
 557
 558        if test $# = 0
 559        then
 560                die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
 561        fi
 562
 563        git submodule--helper list --prefix "$wt_prefix" "$@" |
 564        while read mode sha1 stage sm_path
 565        do
 566                die_if_unmatched "$mode"
 567                name=$(git submodule--helper name "$sm_path") || exit
 568
 569                displaypath=$(relative_path "$sm_path")
 570
 571                # Remove the submodule work tree (unless the user already did it)
 572                if test -d "$sm_path"
 573                then
 574                        # Protect submodules containing a .git directory
 575                        if test -d "$sm_path/.git"
 576                        then
 577                                echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
 578                                die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
 579                        fi
 580
 581                        if test -z "$force"
 582                        then
 583                                git rm -qn "$sm_path" ||
 584                                die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
 585                        fi
 586                        rm -rf "$sm_path" &&
 587                        say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
 588                        say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
 589                fi
 590
 591                mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
 592
 593                # Remove the .git/config entries (unless the user already did it)
 594                if test -n "$(git config --get-regexp submodule."$name\.")"
 595                then
 596                        # Remove the whole section so we have a clean state when
 597                        # the user later decides to init this submodule again
 598                        url=$(git config submodule."$name".url)
 599                        git config --remove-section submodule."$name" 2>/dev/null &&
 600                        say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
 601                fi
 602        done
 603}
 604
 605is_tip_reachable () (
 606        sanitize_submodule_env &&
 607        cd "$1" &&
 608        rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
 609        test -z "$rev"
 610)
 611
 612fetch_in_submodule () (
 613        sanitize_submodule_env &&
 614        cd "$1" &&
 615        case "$2" in
 616        '')
 617                git fetch ;;
 618        *)
 619                git fetch $(get_default_remote) "$2" ;;
 620        esac
 621)
 622
 623#
 624# Update each submodule path to correct revision, using clone and checkout as needed
 625#
 626# $@ = requested paths (default to all)
 627#
 628cmd_update()
 629{
 630        # parse $args after "submodule ... update".
 631        while test $# -ne 0
 632        do
 633                case "$1" in
 634                -q|--quiet)
 635                        GIT_QUIET=1
 636                        ;;
 637                -i|--init)
 638                        init=1
 639                        ;;
 640                --remote)
 641                        remote=1
 642                        ;;
 643                -N|--no-fetch)
 644                        nofetch=1
 645                        ;;
 646                -f|--force)
 647                        force=$1
 648                        ;;
 649                -r|--rebase)
 650                        update="rebase"
 651                        ;;
 652                --reference)
 653                        case "$2" in '') usage ;; esac
 654                        reference="--reference=$2"
 655                        shift
 656                        ;;
 657                --reference=*)
 658                        reference="$1"
 659                        ;;
 660                -m|--merge)
 661                        update="merge"
 662                        ;;
 663                --recursive)
 664                        recursive=1
 665                        ;;
 666                --checkout)
 667                        update="checkout"
 668                        ;;
 669                --depth)
 670                        case "$2" in '') usage ;; esac
 671                        depth="--depth=$2"
 672                        shift
 673                        ;;
 674                --depth=*)
 675                        depth=$1
 676                        ;;
 677                --)
 678                        shift
 679                        break
 680                        ;;
 681                -*)
 682                        usage
 683                        ;;
 684                *)
 685                        break
 686                        ;;
 687                esac
 688                shift
 689        done
 690
 691        if test -n "$init"
 692        then
 693                cmd_init "--" "$@" || return
 694        fi
 695
 696        cloned_modules=
 697        git submodule--helper list --prefix "$wt_prefix" "$@" | {
 698        err=
 699        while read mode sha1 stage sm_path
 700        do
 701                die_if_unmatched "$mode"
 702                if test "$stage" = U
 703                then
 704                        echo >&2 "Skipping unmerged submodule $prefix$sm_path"
 705                        continue
 706                fi
 707                name=$(git submodule--helper name "$sm_path") || exit
 708                url=$(git config submodule."$name".url)
 709                branch=$(get_submodule_config "$name" branch master)
 710                if ! test -z "$update"
 711                then
 712                        update_module=$update
 713                else
 714                        update_module=$(git config submodule."$name".update)
 715                        if test -z "$update_module"
 716                        then
 717                                update_module="checkout"
 718                        fi
 719                fi
 720
 721                displaypath=$(relative_path "$prefix$sm_path")
 722
 723                if test "$update_module" = "none"
 724                then
 725                        echo "Skipping submodule '$displaypath'"
 726                        continue
 727                fi
 728
 729                if test -z "$url"
 730                then
 731                        # Only mention uninitialized submodules when its
 732                        # path have been specified
 733                        test "$#" != "0" &&
 734                        say "$(eval_gettext "Submodule path '\$displaypath' not initialized
 735Maybe you want to use 'update --init'?")"
 736                        continue
 737                fi
 738
 739                if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
 740                then
 741                        git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$prefix" --path "$sm_path" --name "$name" --url "$url" ${reference:+"$reference"} ${depth:+"$depth"} || exit
 742                        cloned_modules="$cloned_modules;$name"
 743                        subsha1=
 744                else
 745                        subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
 746                                git rev-parse --verify HEAD) ||
 747                        die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
 748                fi
 749
 750                if test -n "$remote"
 751                then
 752                        if test -z "$nofetch"
 753                        then
 754                                # Fetch remote before determining tracking $sha1
 755                                (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
 756                                die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
 757                        fi
 758                        remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
 759                        sha1=$(sanitize_submodule_env; cd "$sm_path" &&
 760                                git rev-parse --verify "${remote_name}/${branch}") ||
 761                        die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
 762                fi
 763
 764                if test "$subsha1" != "$sha1" || test -n "$force"
 765                then
 766                        subforce=$force
 767                        # If we don't already have a -f flag and the submodule has never been checked out
 768                        if test -z "$subsha1" && test -z "$force"
 769                        then
 770                                subforce="-f"
 771                        fi
 772
 773                        if test -z "$nofetch"
 774                        then
 775                                # Run fetch only if $sha1 isn't present or it
 776                                # is not reachable from a ref.
 777                                is_tip_reachable "$sm_path" "$sha1" ||
 778                                fetch_in_submodule "$sm_path" ||
 779                                die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
 780
 781                                # Now we tried the usual fetch, but $sha1 may
 782                                # not be reachable from any of the refs
 783                                is_tip_reachable "$sm_path" "$sha1" ||
 784                                fetch_in_submodule "$sm_path" "$sha1" ||
 785                                die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
 786                        fi
 787
 788                        # Is this something we just cloned?
 789                        case ";$cloned_modules;" in
 790                        *";$name;"*)
 791                                # then there is no local change to integrate
 792                                update_module=checkout ;;
 793                        esac
 794
 795                        must_die_on_failure=
 796                        case "$update_module" in
 797                        checkout)
 798                                command="git checkout $subforce -q"
 799                                die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
 800                                say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
 801                                ;;
 802                        rebase)
 803                                command="git rebase"
 804                                die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
 805                                say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
 806                                must_die_on_failure=yes
 807                                ;;
 808                        merge)
 809                                command="git merge"
 810                                die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
 811                                say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
 812                                must_die_on_failure=yes
 813                                ;;
 814                        !*)
 815                                command="${update_module#!}"
 816                                die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
 817                                say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
 818                                must_die_on_failure=yes
 819                                ;;
 820                        *)
 821                                die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
 822                        esac
 823
 824                        if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
 825                        then
 826                                say "$say_msg"
 827                        elif test -n "$must_die_on_failure"
 828                        then
 829                                die_with_status 2 "$die_msg"
 830                        else
 831                                err="${err};$die_msg"
 832                                continue
 833                        fi
 834                fi
 835
 836                if test -n "$recursive"
 837                then
 838                        (
 839                                prefix="$prefix$sm_path/"
 840                                sanitize_submodule_env
 841                                cd "$sm_path" &&
 842                                eval cmd_update
 843                        )
 844                        res=$?
 845                        if test $res -gt 0
 846                        then
 847                                die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
 848                                if test $res -eq 1
 849                                then
 850                                        err="${err};$die_msg"
 851                                        continue
 852                                else
 853                                        die_with_status $res "$die_msg"
 854                                fi
 855                        fi
 856                fi
 857        done
 858
 859        if test -n "$err"
 860        then
 861                OIFS=$IFS
 862                IFS=';'
 863                for e in $err
 864                do
 865                        if test -n "$e"
 866                        then
 867                                echo >&2 "$e"
 868                        fi
 869                done
 870                IFS=$OIFS
 871                exit 1
 872        fi
 873        }
 874}
 875
 876set_name_rev () {
 877        revname=$( (
 878                sanitize_submodule_env
 879                cd "$1" && {
 880                        git describe "$2" 2>/dev/null ||
 881                        git describe --tags "$2" 2>/dev/null ||
 882                        git describe --contains "$2" 2>/dev/null ||
 883                        git describe --all --always "$2"
 884                }
 885        ) )
 886        test -z "$revname" || revname=" ($revname)"
 887}
 888#
 889# Show commit summary for submodules in index or working tree
 890#
 891# If '--cached' is given, show summary between index and given commit,
 892# or between working tree and given commit
 893#
 894# $@ = [commit (default 'HEAD'),] requested paths (default all)
 895#
 896cmd_summary() {
 897        summary_limit=-1
 898        for_status=
 899        diff_cmd=diff-index
 900
 901        # parse $args after "submodule ... summary".
 902        while test $# -ne 0
 903        do
 904                case "$1" in
 905                --cached)
 906                        cached="$1"
 907                        ;;
 908                --files)
 909                        files="$1"
 910                        ;;
 911                --for-status)
 912                        for_status="$1"
 913                        ;;
 914                -n|--summary-limit)
 915                        summary_limit="$2"
 916                        isnumber "$summary_limit" || usage
 917                        shift
 918                        ;;
 919                --summary-limit=*)
 920                        summary_limit="${1#--summary-limit=}"
 921                        isnumber "$summary_limit" || usage
 922                        ;;
 923                --)
 924                        shift
 925                        break
 926                        ;;
 927                -*)
 928                        usage
 929                        ;;
 930                *)
 931                        break
 932                        ;;
 933                esac
 934                shift
 935        done
 936
 937        test $summary_limit = 0 && return
 938
 939        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 940        then
 941                head=$rev
 942                test $# = 0 || shift
 943        elif test -z "$1" || test "$1" = "HEAD"
 944        then
 945                # before the first commit: compare with an empty tree
 946                head=$(git hash-object -w -t tree --stdin </dev/null)
 947                test -z "$1" || shift
 948        else
 949                head="HEAD"
 950        fi
 951
 952        if [ -n "$files" ]
 953        then
 954                test -n "$cached" &&
 955                die "$(gettext "The --cached option cannot be used with the --files option")"
 956                diff_cmd=diff-files
 957                head=
 958        fi
 959
 960        cd_to_toplevel
 961        eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
 962        # Get modified modules cared by user
 963        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 964                sane_egrep '^:([0-7]* )?160000' |
 965                while read mod_src mod_dst sha1_src sha1_dst status sm_path
 966                do
 967                        # Always show modules deleted or type-changed (blob<->module)
 968                        if test "$status" = D || test "$status" = T
 969                        then
 970                                printf '%s\n' "$sm_path"
 971                                continue
 972                        fi
 973                        # Respect the ignore setting for --for-status.
 974                        if test -n "$for_status"
 975                        then
 976                                name=$(git submodule--helper name "$sm_path")
 977                                ignore_config=$(get_submodule_config "$name" ignore none)
 978                                test $status != A && test $ignore_config = all && continue
 979                        fi
 980                        # Also show added or modified modules which are checked out
 981                        GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 982                        printf '%s\n' "$sm_path"
 983                done
 984        )
 985
 986        test -z "$modules" && return
 987
 988        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 989        sane_egrep '^:([0-7]* )?160000' |
 990        cut -c2- |
 991        while read mod_src mod_dst sha1_src sha1_dst status name
 992        do
 993                if test -z "$cached" &&
 994                        test $sha1_dst = 0000000000000000000000000000000000000000
 995                then
 996                        case "$mod_dst" in
 997                        160000)
 998                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 999                                ;;
1000                        100644 | 100755 | 120000)
1001                                sha1_dst=$(git hash-object $name)
1002                                ;;
1003                        000000)
1004                                ;; # removed
1005                        *)
1006                                # unexpected type
1007                                eval_gettextln "unexpected mode \$mod_dst" >&2
1008                                continue ;;
1009                        esac
1010                fi
1011                missing_src=
1012                missing_dst=
1013
1014                test $mod_src = 160000 &&
1015                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1016                missing_src=t
1017
1018                test $mod_dst = 160000 &&
1019                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1020                missing_dst=t
1021
1022                display_name=$(relative_path "$name")
1023
1024                total_commits=
1025                case "$missing_src,$missing_dst" in
1026                t,)
1027                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
1028                        ;;
1029                ,t)
1030                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
1031                        ;;
1032                t,t)
1033                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1034                        ;;
1035                *)
1036                        errmsg=
1037                        total_commits=$(
1038                        if test $mod_src = 160000 && test $mod_dst = 160000
1039                        then
1040                                range="$sha1_src...$sha1_dst"
1041                        elif test $mod_src = 160000
1042                        then
1043                                range=$sha1_src
1044                        else
1045                                range=$sha1_dst
1046                        fi
1047                        GIT_DIR="$name/.git" \
1048                        git rev-list --first-parent $range -- | wc -l
1049                        )
1050                        total_commits=" ($(($total_commits + 0)))"
1051                        ;;
1052                esac
1053
1054                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1055                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1056                if test $status = T
1057                then
1058                        blob="$(gettext "blob")"
1059                        submodule="$(gettext "submodule")"
1060                        if test $mod_dst = 160000
1061                        then
1062                                echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1063                        else
1064                                echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1065                        fi
1066                else
1067                        echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1068                fi
1069                if test -n "$errmsg"
1070                then
1071                        # Don't give error msg for modification whose dst is not submodule
1072                        # i.e. deleted or changed to blob
1073                        test $mod_dst = 160000 && echo "$errmsg"
1074                else
1075                        if test $mod_src = 160000 && test $mod_dst = 160000
1076                        then
1077                                limit=
1078                                test $summary_limit -gt 0 && limit="-$summary_limit"
1079                                GIT_DIR="$name/.git" \
1080                                git log $limit --pretty='format:  %m %s' \
1081                                --first-parent $sha1_src...$sha1_dst
1082                        elif test $mod_dst = 160000
1083                        then
1084                                GIT_DIR="$name/.git" \
1085                                git log --pretty='format:  > %s' -1 $sha1_dst
1086                        else
1087                                GIT_DIR="$name/.git" \
1088                                git log --pretty='format:  < %s' -1 $sha1_src
1089                        fi
1090                        echo
1091                fi
1092                echo
1093        done
1094}
1095#
1096# List all submodules, prefixed with:
1097#  - submodule not initialized
1098#  + different revision checked out
1099#
1100# If --cached was specified the revision in the index will be printed
1101# instead of the currently checked out revision.
1102#
1103# $@ = requested paths (default to all)
1104#
1105cmd_status()
1106{
1107        # parse $args after "submodule ... status".
1108        while test $# -ne 0
1109        do
1110                case "$1" in
1111                -q|--quiet)
1112                        GIT_QUIET=1
1113                        ;;
1114                --cached)
1115                        cached=1
1116                        ;;
1117                --recursive)
1118                        recursive=1
1119                        ;;
1120                --)
1121                        shift
1122                        break
1123                        ;;
1124                -*)
1125                        usage
1126                        ;;
1127                *)
1128                        break
1129                        ;;
1130                esac
1131                shift
1132        done
1133
1134        git submodule--helper list --prefix "$wt_prefix" "$@" |
1135        while read mode sha1 stage sm_path
1136        do
1137                die_if_unmatched "$mode"
1138                name=$(git submodule--helper name "$sm_path") || exit
1139                url=$(git config submodule."$name".url)
1140                displaypath=$(relative_path "$prefix$sm_path")
1141                if test "$stage" = U
1142                then
1143                        say "U$sha1 $displaypath"
1144                        continue
1145                fi
1146                if test -z "$url" ||
1147                {
1148                        ! test -d "$sm_path"/.git &&
1149                        ! test -f "$sm_path"/.git
1150                }
1151                then
1152                        say "-$sha1 $displaypath"
1153                        continue;
1154                fi
1155                if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1156                then
1157                        set_name_rev "$sm_path" "$sha1"
1158                        say " $sha1 $displaypath$revname"
1159                else
1160                        if test -z "$cached"
1161                        then
1162                                sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1163                        fi
1164                        set_name_rev "$sm_path" "$sha1"
1165                        say "+$sha1 $displaypath$revname"
1166                fi
1167
1168                if test -n "$recursive"
1169                then
1170                        (
1171                                prefix="$displaypath/"
1172                                sanitize_submodule_env
1173                                cd "$sm_path" &&
1174                                eval cmd_status
1175                        ) ||
1176                        die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1177                fi
1178        done
1179}
1180#
1181# Sync remote urls for submodules
1182# This makes the value for remote.$remote.url match the value
1183# specified in .gitmodules.
1184#
1185cmd_sync()
1186{
1187        while test $# -ne 0
1188        do
1189                case "$1" in
1190                -q|--quiet)
1191                        GIT_QUIET=1
1192                        shift
1193                        ;;
1194                --recursive)
1195                        recursive=1
1196                        shift
1197                        ;;
1198                --)
1199                        shift
1200                        break
1201                        ;;
1202                -*)
1203                        usage
1204                        ;;
1205                *)
1206                        break
1207                        ;;
1208                esac
1209        done
1210        cd_to_toplevel
1211        git submodule--helper list --prefix "$wt_prefix" "$@" |
1212        while read mode sha1 stage sm_path
1213        do
1214                die_if_unmatched "$mode"
1215                name=$(git submodule--helper name "$sm_path")
1216                url=$(git config -f .gitmodules --get submodule."$name".url)
1217
1218                # Possibly a url relative to parent
1219                case "$url" in
1220                ./*|../*)
1221                        # rewrite foo/bar as ../.. to find path from
1222                        # submodule work tree to superproject work tree
1223                        up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1224                        # guarantee a trailing /
1225                        up_path=${up_path%/}/ &&
1226                        # path from submodule work tree to submodule origin repo
1227                        sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1228                        # path from superproject work tree to submodule origin repo
1229                        super_config_url=$(resolve_relative_url "$url") || exit
1230                        ;;
1231                *)
1232                        sub_origin_url="$url"
1233                        super_config_url="$url"
1234                        ;;
1235                esac
1236
1237                if git config "submodule.$name.url" >/dev/null 2>/dev/null
1238                then
1239                        displaypath=$(relative_path "$prefix$sm_path")
1240                        say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1241                        git config submodule."$name".url "$super_config_url"
1242
1243                        if test -e "$sm_path"/.git
1244                        then
1245                        (
1246                                sanitize_submodule_env
1247                                cd "$sm_path"
1248                                remote=$(get_default_remote)
1249                                git config remote."$remote".url "$sub_origin_url"
1250
1251                                if test -n "$recursive"
1252                                then
1253                                        prefix="$prefix$sm_path/"
1254                                        eval cmd_sync
1255                                fi
1256                        )
1257                        fi
1258                fi
1259        done
1260}
1261
1262# This loop parses the command line arguments to find the
1263# subcommand name to dispatch.  Parsing of the subcommand specific
1264# options are primarily done by the subcommand implementations.
1265# Subcommand specific options such as --branch and --cached are
1266# parsed here as well, for backward compatibility.
1267
1268while test $# != 0 && test -z "$command"
1269do
1270        case "$1" in
1271        add | foreach | init | deinit | update | status | summary | sync)
1272                command=$1
1273                ;;
1274        -q|--quiet)
1275                GIT_QUIET=1
1276                ;;
1277        -b|--branch)
1278                case "$2" in
1279                '')
1280                        usage
1281                        ;;
1282                esac
1283                branch="$2"; shift
1284                ;;
1285        --cached)
1286                cached="$1"
1287                ;;
1288        --)
1289                break
1290                ;;
1291        -*)
1292                usage
1293                ;;
1294        *)
1295                break
1296                ;;
1297        esac
1298        shift
1299done
1300
1301# No command word defaults to "status"
1302if test -z "$command"
1303then
1304    if test $# = 0
1305    then
1306        command=status
1307    else
1308        usage
1309    fi
1310fi
1311
1312# "-b branch" is accepted only by "add"
1313if test -n "$branch" && test "$command" != add
1314then
1315        usage
1316fi
1317
1318# "--cached" is accepted only by "status" and "summary"
1319if test -n "$cached" && test "$command" != status && test "$command" != summary
1320then
1321        usage
1322fi
1323
1324"cmd_$command" "$@"